#ifndef   	__SWPARAM_H_
# define   	__SWPARAM_H_

#include "simparam.h"

#define POP_SIZE 100
#define NUM_GEN 200
#define NUM_POP 10

#define ELIT_PERC 5
#define MUT_PROB 0.5
#define INSERT_PROB 0.1
#define INIT_NUM_VIA MAX_NUM_VIA-1

// Min. percentage of pop_size that must be available to derive the next generation from
// Elitism + successfully executed packets
#define SUCC_PERC 0.8


// Initial throughput in clocks/packet
#define THROUGHPUT 200


// Ejection rate control - HW
#define EJECT_PER  THROUGHPUT
#define EJECT_THR0 20
#define EJECT_THR1 25


// Dispatch rate control - SW/HW
#define DISP_ADP_ENA true
#define DISP_ADP_PER 31  /* In terms of number of output packets */
#define MIN_EJ_RATIO 0.05
#define MAX_EJ_RATIO (1-SUCC_PERC)

// DISPATCH adaptation parameters
#define RELAX_RATE 1.0
#define TIGHT_RATE 0.1


#define MIGR_ENABLE true
// Number of generations between two migration events
#define MIGR_GEN_GAP 10
#define MIGR_PERC 2


// NOT to be changed
#define ELIT_NUM (((((POP_SIZE * ELIT_PERC)/100)+1)/2)*2)
#define MIGR_NUM    ((POP_SIZE * MIGR_PERC)/100)

#endif /* __SWPARAM_H_ */
