
module block_ram (
 input clockA,
 input clockB,
 
 output reg [RAM_WIDTH-1:0] odataA,
 input [RAM_ADDR_BITS-1:0] addA,
 input [RAM_WIDTH-1:0] idataA,
 input  enableA,
 input  write_enableA,

 output reg [RAM_WIDTH-1:0] odataB,
 input [RAM_ADDR_BITS-1:0] addB,
 input [RAM_WIDTH-1:0] idataB,
 input  enableB,
 input  write_enableB
);

   parameter RAM_WIDTH = 32;
   parameter RAM_ADDR_BITS = 10;

   (* RAM_STYLE="BLOCK" *)
   reg [RAM_WIDTH-1:0] block_ram [(2**RAM_ADDR_BITS)-1:0];

/*   reg [RAM_WIDTH-1:0] odataA, odataB;
   wire [RAM_ADDR_BITS-1:0] addA, addB;
   wire [RAM_WIDTH-1:0] idataA, idataB; */

   //  The forllowing code is only necessary if you wish to initialize the RAM 
   //  contents via an external file (use $readmemb for binary data)
/*   initial
      $readmemh("<data_file_name>", <ram_name>, <begin_address>, <end_address>); */

   always @(posedge clockA)
      if (enableA) begin
         if (write_enableA)
            block_ram[addA] <= idataA;
         odataA <= block_ram[addA];
      end
      
   always @(posedge clockB)
      if (enableB) begin
         if (write_enableB)
            block_ram[addB] <= idataB;
         odataB <= block_ram[addB];
      end

endmodule
