`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    14:24:19 05/13/2014 
// Design Name: 
// Module Name:    synth_top 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module synth_top(
 input rst,
 input clk,
 
 input  wr_req_in,
 input  [IO_W-1:0] wr_pack_in,
 input  [15:0] wr_add_in,
 output wr_grant_in,
 input  wr_valid_in, // INW

 output wr_req_en,
 output [IO_W-1:0] wr_pack_en,
 output  [15:0] wr_add_en,
 input  wr_grant_en,
 output wr_valid_en, // ENW

 input  [MEM_ADD_W:0] cpu_add,
 input   cpu_wr,
 input   cpu_cs,
 output [WORD_W-1:0] cpu_data_i,
 input  [WORD_W-1:0] cpu_data_o // Processor interface
 
    );
parameter WORD_W = 32;    // Width of each word, same as width of the memory interface. Must be even.
parameter MEM_ADD_W = 10;

localparam IO_W = WORD_W/2;

 wire  [3:0] wr_req;
 wire  [4*IO_W-1:0] wr_pack;
 wire [3:0] wr_grant;
 wire  [3:0] wr_valid; // CNW interface - downstream ports, driven by an upstream proc_node

/*
proc_node proc_node0(
 .rst(rst),
 .clk(clk),

 .wr_req_ds({wr_req, wr_req_in}),
 .wr_pack_ds({wr_pack, wr_pack_in}),
 .wr_grant_ds({wr_grant, wr_grant_in}),
 .wr_valid_ds({wr_valid, wr_valid_in}), // IENW & CNW interface - downstream ports, driven by an upstream proc_node
 
 .wr_req_us({wr_req, wr_req_en}),
 .wr_pack_us({wr_pack, wr_pack_en}),
 .wr_grant_us({wr_grant, wr_grant_en}),
 .wr_valid_us({wr_valid, wr_valid_en}), // IENW & CNW interface - upstream ports, to drive a downstream proc_node
 
 .cpu_add(cpu_add),
 .cpu_wr(cpu_wr),
 .cpu_cs(cpu_cs),
 .cpu_data_i(cpu_data_i),
 .cpu_data_o(cpu_data_o) // Processor interface
);
*/

proc_node_with_ie proc_node0(
 .rst(rst),
 .clk(clk),

 .ie_req_ds(wr_req_in),
 .ie_pack_ds(wr_pack_in),
 .ie_add_ds(wr_add_in),
 .ie_grant_ds(wr_grant_in),
 .ie_valid_ds(wr_valid_in), // IENW interface - downstream ports, driven by an upstream proc_node
 
 .ie_req_us(wr_req_en),
 .ie_pack_us(wr_pack_en),
 .ie_add_us(wr_add_en),
 .ie_grant_us(wr_grant_en),
 .ie_valid_us(wr_valid_en), // IENW interface - upstream ports, to drive a downstream proc_node
 
 .wr_req_ds(wr_req),
 .wr_pack_ds(wr_pack),
 .wr_grant_ds(wr_grant),
 .wr_valid_ds(wr_valid), // IENW & CNW interface - downstream ports, driven by an upstream proc_node
 
 .wr_req_us(wr_req),
 .wr_pack_us(wr_pack),
 .wr_grant_us(wr_grant),
 .wr_valid_us(wr_valid), // IENW & CNW interface - upstream ports, to drive a downstream proc_node
 
 .cpu_add(cpu_add),
 .cpu_wr(cpu_wr),
 .cpu_cs(cpu_cs),
 .cpu_data_i(cpu_data_i),
 .cpu_data_o(cpu_data_o) // Processor interface
);


endmodule
