#ifndef   	__FIFO_H_
# define   	__FIFO_H_

#include <systemc.h>
#include "if.h"
#include "simparam.h"

class fifo : public fifo_read_if<ftr_t*>,
	     public fifo_write_if<ftr_t*>,
	     public sc_channel {
 public:

  fifo (sc_module_name name, int size_);
  ~fifo ();
  
  virtual void write (ftr_t*);
  virtual ftr_t* read ();
  virtual ftr_t* read_init();
  virtual void read_finalize(int);
  void reset ();
  virtual int num_available ();
  virtual int bytes_free();

 private:
  sc_event read_ev, write_ev;

  ftr_t** data;

  unsigned int  num_write;
  unsigned int  num_read;
  unsigned int  size;

  unsigned int  byte_read, byte_write;
};

typedef fifo    con_t;


#endif 	    /* !__FIFO_H_ */
