#ifndef __FTR_H__
#define __FTR_H__


#include <math.h>
#include <iostream>
#include <stdio.h>



typedef struct ftr_type {
private:
   float *via_x_org;
   float *via_y_org;

public:
   int ID;
   int forward; // 0 => no forward. Else, 1..4 => Forward to up, right, down, left
   bool debug;
   float data;
   int no_via;
   float *via_x;
   float *via_y;
   float entry_x;
   float entry_y;
   float expected_len;
   int foldlevelx, foldlevely; // Present foldlevel (x,y)
   int proc_cost;
   sc_time in_time;
   sc_time out_time;

   char debfilename[20];
   ofstream debfile;

   ftr_type(int id, int size, float firstx, float firsty, bool isdebug) {


      ID = id;
      data = 0;
      via_x_org = new float[size];
      via_y_org = new float[size];
      via_x = via_x_org;
      via_y = via_y_org;
      forward = 0;
      debug = isdebug;
      if(isdebug) {
         sprintf(debfilename, "deb%04d.dat", id);
         debfile.open(debfilename);
         debfile << "#x y mapdata foldx foldy data" << endl;
      }
      no_via = size;
      entry_x = firstx-floorf(firstx);
      via_x[0] = firstx;
      entry_y = firsty-floorf(firsty);
      via_y[0] = firsty;
      expected_len = 0;
      proc_cost = 0;
   }

   ~ftr_type() {
      if(debug) debfile.close();
      delete [] via_x_org;
      delete [] via_y_org;
   }

} ftr_t;

#endif
