#ifndef   	__IF_H_
# define   	__IF_H_
#include "ftr.h"

template < class T >
class fifo_write_if : public sc_interface {
public:
  virtual void write (T) = 0;
  virtual int  num_available() = 0;
  virtual int bytes_free() = 0;
};


template < class T >
class fifo_read_if : public sc_interface {
public:
  virtual T read () = 0;
  virtual T read_init() = 0;
  virtual void read_finalize(int) = 0;
  virtual int num_available() = 0;
};

typedef sc_port<fifo_read_if<ftr_t*> > inp_t;
typedef sc_port<fifo_write_if<ftr_t*> > outp_t;

#endif 	    /* !__IF_H_ */
