#include <systemc.h>
#include "ftr.h"
#include "if.h"
#include "simparam.h"

#define addr(x,y) (x+y*XSIZE)

SC_MODULE (inw_cont) {
private:
   ftr_t *ij_ftr;

public:
   outp_t   ij_out[XSIZE*YSIZE];
   inp_t    ij_inp;
  
   void func() {
      int startxl, startyl; // Starting folding level
      int startx, starty;   // Starting map segment coordinates

      while(true) {
      int tmp;
         ij_ftr = ij_inp->read(); // Blocking read
         startx  = floorf(ij_ftr->via_x[0]);
         starty  = floorf(ij_ftr->via_y[0]);
         ij_ftr->foldlevelx = startxl = startx/XSIZE;
         ij_ftr->foldlevely = startyl = starty/YSIZE;

         startx  = startx%XSIZE;
         starty  = starty%YSIZE;
         if(startxl%2==1) startx = XSIZE-1-startx;
         if(startyl%2==1) starty = YSIZE-1-starty;

         tmp = addr(startx, starty);

         ij_ftr->via_x++;
         ij_ftr->via_y++;
         ij_ftr->no_via--;
         ij_ftr->in_time = sc_time_stamp();

         ij_out[tmp]->write(ij_ftr);
//         cout << "Launched to: " << ij_ftr->via_x[0] << "," << ij_ftr->via_y[0] << " = " << tmp << endl;
      }
   }


SC_CTOR(inw_cont)
{
   SC_THREAD(func);
}
};
