#include <stdio.h>

void main(int argc, char *argv[]) {
  FILE *fp=fopen("codes/simparam.h", "w");

  int base_dl_tout, dl_tout_cost, fifo_depth, throughput, foldingx, foldingy, mapx, mapy, num_pack;

  if(argc != 10)
    printf("Error! Cannot create simparam.h\n");
  else {
    base_dl_tout = atoi(argv[1]);
    dl_tout_cost = atoi(argv[2]);
    fifo_depth = atoi(argv[3]);
    throughput = atoi(argv[4]);
    foldingx = atoi(argv[5]);
    foldingy = atoi(argv[6]);
    mapx = atoi(argv[7]);
    mapy = atoi(argv[8]);
    num_pack = atoi(argv[9]);

    fprintf(fp, "#ifndef   	__SIMPARAM_H_\n");
    fprintf(fp, "# define   	__SIMPARAM_H_\n\n");

    fprintf(fp, "const sc_time CLK_PER (10, SC_NS);  // Clock period\n");
    fprintf(fp, "const sc_time PROC_TIME (100, SC_NS); // Data processing time for 1 packet in a proc node\n");
    fprintf(fp, "const sc_time ROUTE_DELAY(600, SC_NS); // Normal routing calculation time\n");
    fprintf(fp, "const sc_time VIA_PROC_TIME(200, SC_NS); // Extra routing calculation time/extra via point inside the segment\n\n");

    fprintf(fp, "const sc_time BASE_DL_TOUT (%d, SC_NS);  // Basic time out for deadlock detection\n", base_dl_tout);
    fprintf(fp, "const sc_time DL_TOUT_COST (%d, SC_NS);    // Time out increment for each unit cost already invested into the packet\n\n", dl_tout_cost);

    fprintf(fp, "#define NUM_PACK %d\n\n", num_pack);

    fprintf(fp, "#define THROUGHPUT %d\n\n", throughput);

    fprintf(fp, "#define DEBUG_PACKETS false\n");
    fprintf(fp, "#define DEBUG_NODES   false\n\n");

    fprintf(fp, "#define DIAG_SEP_TH 0.1\n\n");

    fprintf(fp, "#define BYTES_PER_VIA 4\n");
    fprintf(fp, "#define BYTES_OHEAD 18\n\n");

    fprintf(fp, "#define MAX_NUM_VIA 4\n\n");

    fprintf(fp, "#define XSIZE %d\n", mapx/foldingx);
    fprintf(fp, "#define YSIZE %d\n\n", mapy/foldingy);

    fprintf(fp, "#define XLEVELS %d\n", foldingx);
    fprintf(fp, "#define YLEVELS %d\n\n", foldingy);

    fprintf(fp, "#define BYTES_FIFO_DEPTH %d\n", fifo_depth);
    fprintf(fp, "#define FIFO_W 4\n\n");

    fprintf(fp, "#endif /* __SIMPARAM_H_ */\n");
  }

  fclose(fp);

  int run_num;
  fp=fopen("run_num.dat", "r");
  fscanf(fp, "%d", &run_num);
  fclose(fp);
  fp=fopen("run_num.dat", "w");
  fprintf(fp, "%d\n", run_num+1);
  fclose(fp);

  fp=fopen("script.sh", "w");

  fprintf(fp, "date \"+%%H:%%M:%%S\"\n");
  fprintf(fp, "echo %d\n", run_num);
  fprintf(fp, "make >& junk\n");
  fprintf(fp, "./runme.x >& junk\n");
  fprintf(fp, "tail -14 junk > results/run.log.%d\n", run_num);
  fprintf(fp, "mv codes/simparam.h results/simparam.h.%d\n", run_num);
  fprintf(fp, "mv network_load.log results/network_load.log.%d\n", run_num);
  fprintf(fp, "mv act_packets.log results/act_packets.log.%d\n", run_num);

  fclose(fp);

}
